﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AvalonRFZero.PRG;
using AvalonRFZero.Libs;

namespace AvalonRFZero.Engines
{
    class EngineRandom : IEngine
    {
        public string engineName { set; get; }
        public string engineParams { set; get; }
        public int RRobinNumber { set; get; }
        public string moveMessage { set; get; } = string.Empty;

        // ReversiNET6.MctsValue MctsVal;

        Random random;
        public EngineRandom(string engineName, string engineParams)
        {
            this.engineName = engineName;
            this.engineParams = engineParams;
            this.RRobinNumber = 0; // Does not need RRobin for now.
            
            random = new Random(StaticMath8Stars.GetSlowRandomSeed());
        }

        public int[] ShowBestMove(byte[] Position)
        {
            List<int[]> allMovesList = StaticMath8Stars.GetAllMoves(Position);

            int rndMoveNumber = random.Next(0, allMovesList.Count);

            int moveRow = allMovesList[rndMoveNumber][0];
            int moveCol = allMovesList[rndMoveNumber][1];

            return new int[] { moveRow, moveCol };
        }

        // This function is just a template for now
        public BestMoveData ShowsBestMoveAndStat(byte[] Position)
        {
            int[] BestMove = ShowBestMove(Position);

            BestMoveData bestMoveData = new BestMoveData()
            {
                BestMove = BestMove,
            };

            return bestMoveData;
        }

        public string ShowEngineInfo() 
        {
            return "Engine Random";
        }
    }
}
