﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AvalonRFZero.PRG
{
    //public enum NNWidth { N96, N128, N192, N256, N512 };
    
    public enum NNClass { ValueNet, PolicyNet };

    public enum pNNVersion { pNN01 }; // Version for policy NN

    internal static class AppConst
    {
        public const string NNExtString = ".bin";
        public const string TxtExtString = ".txt";

        // Dir that stores NN for SQL mining process
        public const string SqlMiningDir = @"BattleNet\SqlMining\";

        // Dir that stores NN for Rounnd robin SQL tournament.
        public const string SqlTournamentDir = @"BattleNet\SqlTournament\";

        public const string SqlTournamentSetupFile = @"SETUP\SqlTournament.txt";

        public const string savedNetFilePath = @"BattleNet\";

        public const string test258Dir = @"Test\M258\";

        public enum SqlMatchType { Train, RoundRobin }

        public const int GamesForSqlAutoTournament = 4;

        public static string NNForMining(int EpochID)
        {
            string NNFileName = NetNameForSQLTournament(EpochID: EpochID);

            return $"{AppConst.SqlMiningDir}{NNFileName}";
        }

        public static string NNForSqlTournament(int EpochID)
        {
            string NNFileName = NetNameForSQLTournament(EpochID: EpochID);

            return $"{AppConst.SqlTournamentDir}{NNFileName}";
        }


        public static string PolNetForMining(int EpochID) 
        {
            string NNFileName = PolNetNameForSQLTournament(EpochID: EpochID);

            return $"{AppConst.SqlMiningDir}{NNFileName}";
        }



        public static string PolNetForSqlTournament(int EpochID) 
        {
            string NNFileName = PolNetNameForSQLTournament(EpochID: EpochID);
            
            return $"{AppConst.SqlTournamentDir}{NNFileName}";
        }

        public static string FileFor258()
        {
            string FileName = "LogFile.txt";
            return $"{AppConst.test258Dir}{FileName}";
        }

        public static string EngineNameForSQLTournament(int EpochID)
        {
            return $"SQL_{EpochID}";
        }

        public static string NetNameForSQLTournament(int EpochID)
        {
            return $"ValNetSQL_{EpochID}{AppConst.NNExtString}";
        }

        public static string PolNetNameForSQLTournament(int EpochID)
        {
            return $"PolNetSQL_{EpochID}{AppConst.NNExtString}";
        }
    }
}
